local function updateTank(self, event)
    if IsInGroup() then
        local groupType = IsInRaid() and "raid" or "party"
        -- just go through the whole thing if you're in a raid since groups can be moved
        for i = 1, (IsInRaid() and 40 or GetNumGroupMembers()) do
            local unit = groupType .. i
            
            if UnitGroupRolesAssigned(unit) == "TANK" then
                setTank(self.mdButton, unit)
                break;
            end
        end
    end
end

function setTank(button, unit)
    button:SetAttribute("unit", unit)
end

local frame = CreateFrame("Frame")

frame.mdButton = CreateFrame("Button", "MisdirectTankButton", UIParent, "SecureActionButtonTemplate")
frame.mdButton:SetAttribute("type", "spell")
frame.mdButton:SetAttribute("spell", "Misdirection")
frame.mdButton:SetAttribute("checkselfcast", false)
frame.mdButton:SetAttribute("checkfocuscast", false)

frame:RegisterEvent("GROUP_ROSTER_UPDATE")
frame:SetScript("OnEvent", updateTank)